<?php

namespace App;

use App\Services\UserService;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use App\Traits\ModelTimeFormat;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;

class Waybill extends Model
{
    use ModelTimeFormat;
    use SoftDeletes;
    protected $fillable=[
        'status','type','waybill_number','owner_id','wms_bill_number','origination','destination','recipient','recipient_mobile','charge','ordering_remark',
        'carrier_id','carrier_bill','origination_city_id','destination_city_id','warehouse_weight','warehouse_weight_unit_id','carrier_weight','carrier_weight_unit_id','carType_id',
        'car_owner_info','fee','pick_up_fee','other_fee','collect_fee','dispatch_remark','waybill_price_model_id','warehouse_weight_other','warehouse_weight_unit_id_other'
        ,'carrier_weight_other','carrier_weight_unit_id_other','source_bill','mileage','amount','inquire_tel','amount_unit_id','other_charge','other_charge_remark','deliver_at'
    ];

    public function owner(){
        return $this->hasOne('App\Owner','id','owner_id');
    }
    public function carrier(){
        return $this->hasOne('App\Carrier','id','carrier_id');
    }
    public function originationCity(){
        return $this->hasOne('App\City','id','origination_city_id');
    }
    public function destinationCity(){
        return $this->hasOne('App\City','id','destination_city_id');
    }
    public function wmsCommodities(){
        return $this->hasMany('App\WMSWaybillOrder','OrderNo','wms_bill_number');
    }
    public function priceModel(){
        return $this->hasOne('App\WaybillPriceModel','id','waybill_price_model_id');
    }
    public function amountUnit(){
        return $this->hasOne('App\Unit','id','amount_unit_id');
    }
    public function warehouseWeightUnit(){
        return $this->hasOne('App\Unit','id','warehouse_weight_unit_id');
    }
    public function carrierWeightUnit(){
        return $this->hasOne('App\Unit','id','carrier_weight_unit_id');
    }
    public function warehouseWeightUnitOther(){
        return $this->hasOne('App\Unit','id','warehouse_weight_unit_id_other');
    }
    public function carrierWeightUnitOther(){
        return $this->hasOne('App\Unit','id','carrier_weight_unit_id_other');
    }
    public function carType(){
        return $this->hasOne('App\CarType','id','carType_id');
    }
    public function waybillAuditLogs(){
        return $this->hasMany('App\WaybillAuditLog','waybill_id','id');
    }
    public function uploadFile(){
        return $this->hasOne('App\UploadFile','table_id','id')->where('table_name','waybills');
    }


    static public function setWeightByOrderCode($orderCode,$weight){
        if(empty($orderCode))return;
        $waybill=Waybill::query()->where('wms_bill_number',$orderCode)->where('status','!=','已完结')
            ->where('status','!=','无模型')->first();
        if ($waybill){
            $waybill->warehouse_weight_other=$weight;
            $waybill->warehouse_weight_unit_id_other=1;
            $waybill->update();
        }
    }


    /**
     * @return Builder
     */
    public static function filterAuthorities(){
        $owner_ids=app('UserService')->getPermittingOwnerIds(auth()->user());
        return (new static)->newQuery()->whereIn('owner_id',$owner_ids);
    }


}
